include \masm32\include\masm32rt.inc

uselib wsock32
uselib advapi32
DlgProc			PROTO	:HWND,:UINT,:WPARAM,:LPARAM
ChgTxtClr		PROTO	:HWND,:DWORD,:DWORD,:WPARAM,:LPARAM
FindComputerName	PROTO
GetScreenSaverState	PROTO
getip			PROTO

IDD_MAIN		equ 101
NULL			equ 0

.data
;HKLM
    lpszComputerNameSubKey		DB  "SYSTEM\CurrentControlSet\Control\ComputerName\ComputerName",0
    lpszWinLogonSubKey			DB	"SOFTWARE\Microsoft\Windows NT\CurrentVersion\Winlogon",0
    lpszComputerNameValueName   DB  "ComputerName",0
    lpszScreenSaverSubKey		DB	".DEFAULT\Control Panel\Desktop",0
    lpszScreenSaverValueName	DB	"ScreenSaveActive",0
	szMBCapt					DB	"Registry Error",0
	szNoFindKey					DB	"Key not present.",0
	szNoFindVal					DB	"Value not present.",0
    MsgActive					DB	"Active",0
    MsgInactive					DB	"Inactive",0
    szColon						BYTE	":", 0
    TimeFormat					DB	"h':'mm':'ss tt"
    TimeStr						DB 	72 Dup (0)
    
    IDD_MAIN                	equ 101
	IDC_STC1               		equ 102
	IDC_STC2                	equ 103
	IDC_STC4                	equ 105
	IDC_STC3                	equ 104
	IDC_STC5                	equ 106
	IDC_STC6                	equ 107
	IDC_STC7                	equ 108
	
	MyTimer						equ 400
	MyInterval					equ 1000

.data?
hInstance	dd ?
lpbData	DD 256 Dup (?)
lpbSCRData	DD 256 Dup (?)
lpcbData	DD ?
lpdwType	DD ?
VBufLen	dd ?
SCRVBufLen	DD ?
Buffer	db 1024 dup(?)
wdat	WSADATA <?>
LocalTime	SYSTEMTIME <?>
lpbIP	DD ?

.code
start:
	invoke	GetModuleHandle,NULL
	mov	hInstance,eax
GetTime:
	invoke	GetLocalTime, ADDR LocalTime
Init:
	invoke	InitCommonControls
FindComputer:
	invoke	FindComputerName
IsScrSvrOn:
	invoke	GetScreenSaverState
Get_IP:
	invoke	getip
DialogBox:
	invoke	DialogBoxParam,hInstance,IDD_MAIN,NULL,addr DlgProc,NULL
EndProcs:
	invoke	ExitProcess,0

;########################################################################
DlgProc	proc	hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL 	hdc:HDC
	LOCAL	lpszHour[24]:BYTE
	LOCAL	lpszMinute[24]:BYTE
	LOCAL	lpszSecond[24]:BYTE
	LOCAL	TimeStr2[72]:BYTE
	invoke memfill,addr lpszHour,24,0
	invoke memfill,addr lpszMinute,24,0
	invoke memfill,addr lpszSecond,24,0
	invoke memfill,addr TimeStr2,72,0
	mov	eax,uMsg
INITDIALOG:
	.if	eax==WM_INITDIALOG
		;initialization here
	Set_Timer:
		invoke 	SetTimer,hWin,MyTimer,MyInterval,0
	Get_Time:
		invoke 	GetTimeFormat,LOCALE_USER_DEFAULT, NULL, NULL, offset TimeFormat, addr TimeStr2, 72
		INVOKE 	SendDlgItemMessage,hWin,IDC_STC7,WM_SETTEXT, 0, addr TimeStr2
		invoke 	GetDlgItem, hWin, 108
		invoke 	InvalidateRgn, eax, NULL, TRUE
	    INVOKE	SendDlgItemMessage,hWin,IDC_STC2,WM_SETTEXT, 0, OFFSET lpbData+NULL
	    INVOKE	SendDlgItemMessage,hWin,IDC_STC4,WM_SETTEXT, 0, DWORD PTR [lpbIP]+NULL
	
	    .if [lpbSCRData]=="1"
	    	lea eax, MsgActive
	    .else
	    	lea eax, MsgInactive
	    .endif
	    INVOKE 	SendDlgItemMessage,hWin,IDC_STC6,WM_SETTEXT, 0, eax
	.elseif eax==WM_CTLCOLORSTATIC	
;		invoke GetDlgItem,hWin,IDC_STC6
;		.if eax==lParam
;			invoke SetBkMode,wParam,TRANSPARENT
			.if [lpbSCRData]=="1"
;				invoke SetTextColor,wParam,Red
				invoke ChgTxtClr,hWin,IDC_STC6,Red,wParam,lParam
			.else
;				invoke SetTextColor,wParam,Green
				invoke ChgTxtClr,hWin,IDC_STC6,Green,wParam,lParam
			.endif
;			invoke GetSysColorBrush, COLOR_BTNFACE
;		ret
;		.endif
	.elseif	eax==WM_COMMAND
		mov edx,wParam
		movzx eax,dx
		shr edx,16
		.if edx==BN_CLICKED
			.if eax==IDOK
				invoke	SendMessage,hWin,WM_CLOSE,NULL,NULL
			.elseif eax==IDCANCEL
				invoke	SendMessage,hWin,WM_CLOSE,NULL,NULL
			.endif
		.endif
	.elseif eax==WM_TIMER
		invoke 	GetTimeFormat,LOCALE_USER_DEFAULT, NULL, NULL, offset TimeFormat, addr TimeStr2, 72
		INVOKE 	SendDlgItemMessage,hWin,IDC_STC7,WM_SETTEXT, 0, addr TimeStr2
		invoke 	GetDlgItem, hWin, IDC_STC7
		invoke 	InvalidateRgn, eax, NULL, TRUE		
	.elseif	eax==WM_CLOSE
		invoke 	KillTimer,hWin,MyTimer
		invoke	EndDialog,hWin,0
	.else
		mov	eax,FALSE
		ret
	.endif
	mov	eax,TRUE
	ret
DlgProc endp

ChgTxtClr proc hWin:HWND,DlgItm:DWORD,Color:DWORD,wParam:WPARAM,lParam:LPARAM
ChangeTextColor:
	invoke GetDlgItem,hWin,DlgItm
	;.if eax==lParam
		invoke SetBkMode,wParam,TRANSPARENT
		invoke SetTextColor,wParam,Color				
		invoke GetSysColorBrush, COLOR_BTNFACE
	;.endif
	ret
ChgTxtClr endp


getip proc
    invoke WSAStartup,101h,addr wdat
    invoke gethostbyname,addr lpbData
    mov eax, DWORD PTR [eax+12]
    mov eax, DWORD PTR [eax]          
    mov eax, DWORD PTR [eax]
    invoke inet_ntoa,eax
    mov DWORD PTR [lpbIP],eax
	invoke WSACleanup
    ret  
getip endp

FindComputerName proc
	LOCAL hKey:DWORD
	pusha
	invoke RegOpenKeyEx,HKEY_LOCAL_MACHINE,addr lpszComputerNameSubKey,0,KEY_QUERY_VALUE,addr hKey
    or eax,eax
    jnz ComputerNameKeyNotFound
    mov VBufLen,sizeof Buffer
    invoke RegQueryValueEx,hKey,addr lpszComputerNameValueName,0,addr lpdwType,addr lpbData,addr VBufLen
    cmp eax,ERROR_SUCCESS
    jne ComputerNameValNotFound
    Invoke RegCloseKey,hKey
    jmp ComputerNameEndKey
ComputerNameKeyNotFound:
    INVOKE MessageBox,NULL,addr szNoFindKey,addr szMBCapt,MB_OK
    jmp ComputerNameEndKey
ComputerNameValNotFound:
    INVOKE MessageBox,NULL,addr szNoFindVal,addr szMBCapt,MB_OK
    Invoke RegCloseKey,hKey
ComputerNameEndKey:
	popa
	ret
FindComputerName endp

GetScreenSaverState proc
	LOCAL hKey:DWORD
	pusha
	invoke RegOpenKeyEx,HKEY_USERS,addr lpszScreenSaverSubKey,0,KEY_QUERY_VALUE,addr hKey
    or eax,eax
    jnz ScreenSaverNameKeyNotFound
    mov SCRVBufLen,sizeof Buffer
    invoke RegQueryValueEx,hKey,addr lpszScreenSaverValueName,0,addr lpdwType,addr lpbSCRData,addr SCRVBufLen
    cmp eax,ERROR_SUCCESS
    jne ScreenSaverNameValNotFound
    Invoke RegCloseKey,hKey
    jmp ScreenSaverNameEndKey
ScreenSaverNameKeyNotFound:
    INVOKE MessageBox,NULL,addr szNoFindKey,addr szMBCapt,MB_OK
    jmp ScreenSaverNameEndKey
ScreenSaverNameValNotFound:
    INVOKE MessageBox,NULL,addr szNoFindVal,addr szMBCapt,MB_OK
    Invoke RegCloseKey,hKey
ScreenSaverNameEndKey:
	popa
	ret
GetScreenSaverState endp
end start

;int 3
OPT_DebugA	/Zi	; activate symbols
	OPT_Assembler	mlv615	; must be present in \bin
	OPT_DebugL	/debug /debugtype:cv	; for debugging
	OPT_Linker	linkv614	; must be present in \bin
	OPT_Tmp2Asm 1
	